package com.yworks.eclipse.sample;

import org.eclipse.core.resources.IFile;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.dialogs.WizardNewFileCreationPage;
import org.eclipse.ui.wizards.newresource.BasicNewFileResourceWizard;
import y.io.GraphMLIOHandler;
import y.view.Graph2D;

/**
 * A wizard that generates a yFiles diagram in GraphML format. 
 */
public class GraphDocumentWizard extends BasicNewFileResourceWizard {
  WizardNewFileCreationPage newFilePage;

  public boolean canFinish() {
    return newFilePage.isPageComplete() && (newFilePage.getFileName().endsWith(".graphml"));    
  }

  public boolean performFinish() {
    IFile file = newFilePage.createNewFile();

    GraphMLIOHandler ioh = new GraphMLIOHandler();
    try {
      ioh.write( new Graph2D(), file.getProject().getLocation() + "/" + file.getProjectRelativePath() );
    } catch ( Exception ex ) {
      ex.printStackTrace( System.out );
    }
    return true;
  }

  public void addPages() {
    addPage( newFilePage );
  }

  public void init( IWorkbench workbench, IStructuredSelection selection ) {
    newFilePage = new WizardNewFileCreationPage( "Create a new file", selection );
    newFilePage.setTitle("yFiles Diagram Wizard - Create a new GraphML file");
    newFilePage.setDescription("Choose a filename with .graphml suffix");
    newFilePage.setFileName("diagram1.graphml");
  }

}
