package com.yworks.eclipse.sample;

import org.eclipse.jface.action.Action;

import javax.swing.AbstractAction;
import javax.swing.SwingUtilities;

import java.awt.event.ActionEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

/**
 * Bridge between SWT and Swing
 *
 **/
public class SwingControlledAction extends Action {
  AbstractAction action;
  private PropertyChangeListener listener = new PropertyChangeListener() {
    public void propertyChange( PropertyChangeEvent evt ) {
      if ( "enabled".equals( evt.getPropertyName() ) ) {
        setEnabled( action.isEnabled() );
      }
    }
  };

  public void run() {
    if ( action != null ) {
      try {
        SwingUtilities.invokeAndWait( new Runnable() {
          public void run() {
            action.actionPerformed( new ActionEvent("",0,""));
          }
        } );
      } catch ( Exception e ) {
        throw new RuntimeException( e );
      }
    }
  }

  void setSwingAction( AbstractAction a ) {
    if ( action != null ) {
      action.removePropertyChangeListener( listener );
    }
    action = a;

    setEnabled( a.isEnabled() );
    action.addPropertyChangeListener( listener );
  }
}
