package com.yworks.eclipse.sample.actions;

import com.yworks.eclipse.sample.GraphEditorPart;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IEditorActionDelegate;
import org.eclipse.ui.IEditorPart;

import javax.swing.SwingUtilities;

/**
 * Adjusts the viewport of the view to fit the currently displayed diagram.
 */
public class FitContentAction implements IEditorActionDelegate {
  GraphEditorPart editor = null;

  public void run( IAction action ) {
    if ( editor != null ) {
      SwingUtilities.invokeLater( new Runnable() {
        public void run() {
          editor.getView().fitContent();
          editor.getView().updateView();
        }
      } );
    }
  }

  public void selectionChanged( IAction action, ISelection selection ) {
  }

  public void setActiveEditor( IAction action, IEditorPart targetEditor ) {
    if ( targetEditor instanceof GraphEditorPart ) {
      editor = ( GraphEditorPart ) targetEditor;
    } else {
      editor = null;
    }
  }
}
