package com.yworks.eclipse.sample.actions;

import com.yworks.eclipse.sample.GraphEditorPart;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IEditorActionDelegate;
import org.eclipse.ui.IEditorPart;
import y.view.Graph2DView;

import javax.swing.SwingUtilities;

/**
 * Increases the zoom level of the view.
 */
public class ZoomInAction implements IEditorActionDelegate {
  GraphEditorPart editor;

  public void run( IAction action ) {
    if ( editor != null ) {
      SwingUtilities.invokeLater( new Runnable() {
        public void run() {
          Graph2DView view = editor.getView();
          view.setZoom( view.getZoom() * 1.1 );
          view.updateView();
        }
      } );
    }
  }

  public void selectionChanged( IAction action, ISelection selection ) {
  }

  public void setActiveEditor( IAction action, IEditorPart targetEditor ) {
    if ( targetEditor instanceof GraphEditorPart ) {
      editor = ( GraphEditorPart ) targetEditor;
    } else {
      editor = null;
    }
  }


}
